@use 'colors' as c;
@use 'breakpoints' as b;

// Generate color classes based on the color palette
@each $name, $value in c.$colors {
    .c-#{'' + $name} {
        color: $value;
    }
    .c-bg-#{'' + $name} {
        background-color: $value;
    }
    .c-bd-#{'' + $name} {
        border-color: $value;
    }
}

// Transition with easing function
@mixin transition($property, $time, $easing) {
    transition: $property $time cubic-bezier(#{$easing});
}

// Hover effect
@mixin hover {
    @media screen and (min-width: 1024px), screen and (hover: hover) {
        &:hover {
            cursor: pointer;
        }
        &:hover {
            @content;
        }
    }
}

// Focus effect
@mixin focus {
    @media screen and (min-width: 1024px), screen and (focus: focus) {
        &:focus {
            cursor: pointer;
        }
        &:focus {
            @content;
        }
    }
}

// Media queries (mobile first)
@mixin media($breakpoint, $invert: false) {
    @if ($invert) {
        @media screen and (max-width: map-get(b.$breakpoints, $breakpoint)) {
            @content;
        }
    } @else {
        @media screen and (min-width: map-get(b.$breakpoints, $breakpoint)) {
            @content;
        }
    }
}
